Attribute VB_Name = "settings"
Option Explicit

Public Sub AddRecent(f As String)

  Dim a
  
  For a = 0 To 9
    If CStr(GetSetting(ProgramName, "game", "recent" & a, "")) = f Then Exit Sub
    If CStr(GetSetting(ProgramName, "game", "recent" & a, "")) = "" Then
      Call SaveSetting(ProgramName, "game", "recent" & a, CStr(f))
      Exit Sub
    End If
  Next a
  
  For a = 1 To 9
    Call SaveSetting(ProgramName, "game", "recent" & a - 1, CStr(GetSetting(ProgramName, "game", "recent" & a, "")))
  Next a
  Call SaveSetting(ProgramName, "game", "recent" & 9, CStr(f))
  
End Sub


Public Sub RefreshRecent()

  Dim a, b As String
  
  For a = 0 To 9
    b$ = CStr(GetSetting(ProgramName, "game", "recent" & a, ""))
    If b$ <> "" Then
      frmSMS.mnuRecentGame(a).Visible = True
      frmSMS.mnuRecentGame(a).Caption = Replace(b$, "&", "&&")
    End If
  Next a
    
End Sub



Public Sub settingsload()

  Dim a
  
  VDP_Zoom = CInt(GetSetting(ProgramName, "video", "zoomsize", CInt(0)))
  FullScreenWidth = CLng(GetSetting(ProgramName, "video", "fullscreenwidth", CLng(FullScreenWidth)))
  FullScreenHeight = CLng(GetSetting(ProgramName, "video", "fullscreenheight", CLng(FullScreenHeight)))
  FullScreenOnROM = CBool(GetSetting(ProgramName, "video", "fullscreenonrom", CBool(False)))
  ScreenResolutionChange = CBool(GetSetting(ProgramName, "video", "screenresolutionchange", CBool(True)))
  VDP_Background = CInt(GetSetting(ProgramName, "video", "bgcolor", CInt(13)))
  PSG_Mute = CBool(GetSetting(ProgramName, "audio", "mute", CBool(False)))
  Region = CInt(GetSetting(ProgramName, "vm", "region", 1))
  throttle = CDbl(GetSetting(ProgramName, "vm", "throttle", CDbl(1)))
  rewinding = CBool(GetSetting(ProgramName, "vm", "rewinding", CBool(False)))

  Pad_Up(0) = CInt(GetSetting(ProgramName, "input0", "up", CInt(vbKeyUp)))
  Pad_Down(0) = CInt(GetSetting(ProgramName, "input0", "down", CInt(vbKeyDown)))
  Pad_Left(0) = CInt(GetSetting(ProgramName, "input0", "left", CInt(vbKeyLeft)))
  Pad_Right(0) = CInt(GetSetting(ProgramName, "input0", "right", CInt(vbKeyRight)))
  Pad_1(0) = CInt(GetSetting(ProgramName, "input0", "1", CInt(vbKeyZ)))
  Pad_2(0) = CInt(GetSetting(ProgramName, "input0", "2", CInt(vbKeyX)))
  Pad_3(0) = CInt(GetSetting(ProgramName, "input0", "3", CInt(vbKeyC)))
  Pad_1RapidFire(0) = CInt(GetSetting(ProgramName, "input0", "1rapidfire", CInt(vbKeyA)))
  Pad_2RapidFire(0) = CInt(GetSetting(ProgramName, "input0", "2rapidfire", CInt(vbKeyS)))
  Pad_3RapidFire(0) = CInt(GetSetting(ProgramName, "input0", "3rapidfire", CInt(vbKeyD)))
  Pad_Pause(0) = CInt(GetSetting(ProgramName, "input0", "pause", CInt(vbKeyReturn)))
  Controller_Enable(0) = CBool(GetSetting(ProgramName, "input0", "controllerenable", CBool(False)))
  Controller(0) = CLng(GetSetting(ProgramName, "input0", "controller", CLng(JOYSTICK1)))
  Pad_Type(0) = CInt(GetSetting(ProgramName, "input0", "type", CInt(0)))
    
  Pad_Up(1) = CInt(GetSetting(ProgramName, "input1", "up", CInt(0)))
  Pad_Down(1) = CInt(GetSetting(ProgramName, "input1", "down", CInt(0)))
  Pad_Left(1) = CInt(GetSetting(ProgramName, "input1", "left", CInt(0)))
  Pad_Right(1) = CInt(GetSetting(ProgramName, "input1", "right", CInt(0)))
  Pad_1(1) = CInt(GetSetting(ProgramName, "input1", "1", CInt(0)))
  Pad_2(1) = CInt(GetSetting(ProgramName, "input1", "2", CInt(0)))
  Pad_3(1) = CInt(GetSetting(ProgramName, "input1", "3", CInt(0)))
  Pad_1RapidFire(1) = CInt(GetSetting(ProgramName, "input1", "1rapidfire", CInt(0)))
  Pad_2RapidFire(1) = CInt(GetSetting(ProgramName, "input1", "2rapidfire", CInt(0)))
  Pad_3RapidFire(1) = CInt(GetSetting(ProgramName, "input1", "3rapidfire", CInt(0)))
  Pad_Pause(1) = CInt(GetSetting(ProgramName, "input1", "pause", CInt(0)))
  Controller_Enable(1) = CBool(GetSetting(ProgramName, "input1", "controllerenable", CBool(False)))
  Controller(1) = CLng(GetSetting(ProgramName, "input1", "controller", CLng(JOYSTICK2)))
  Pad_Type(1) = CInt(GetSetting(ProgramName, "input1", "type", CInt(0)))
    
  For a = 0 To 1
    Controller_1(a) = CLng(GetSetting(ProgramName, "input" & a, "c1", CLng(JOY_BUTTON3)))
    Controller_2(a) = CLng(GetSetting(ProgramName, "input" & a, "c2", CLng(JOY_BUTTON2)))
    Controller_3(a) = CLng(GetSetting(ProgramName, "input" & a, "c3", CLng(JOY_BUTTON4)))
    Controller_1RapidFire(a) = CLng(GetSetting(ProgramName, "input" & a, "c1rapidfire", CLng(JOY_BUTTON5)))
    Controller_2RapidFire(a) = CLng(GetSetting(ProgramName, "input" & a, "c2rapidfire", CLng(JOY_BUTTON6)))
    Controller_3RapidFire(a) = CLng(GetSetting(ProgramName, "input" & a, "c3rapidfire", CLng(JOY_BUTTON7)))
    Controller_Pause(a) = CLng(GetSetting(ProgramName, "input" & a, "cpause", CLng(JOY_BUTTON10)))
  Next a
  
End Sub
Public Sub settingssave()

  Dim a
  
  Call SaveSetting(ProgramName, "video", "zoomsize", CInt(VDP_Zoom))
  Call SaveSetting(ProgramName, "video", "fullscreenwidth", CLng(FullScreenWidth))
  Call SaveSetting(ProgramName, "video", "fullscreenheight", CLng(FullScreenHeight))
  Call SaveSetting(ProgramName, "video", "fullscreenonrom", CBool(FullScreenOnROM))
  Call SaveSetting(ProgramName, "video", "screenresolutionchange", CBool(ScreenResolutionChange))
  Call SaveSetting(ProgramName, "video", "bgcolor", CInt(VDP_Background))
  Call SaveSetting(ProgramName, "audio", "mute", CBool(PSG_Mute))
  Call SaveSetting(ProgramName, "vm", "region", CInt(Region))
  Call SaveSetting(ProgramName, "vm", "throttle", CInt(throttle))
  Call SaveSetting(ProgramName, "vm", "rewinding", CBool(rewinding))

  For a = 0 To 1
    Call SaveSetting(ProgramName, "input" & a, "up", CInt(Pad_Up(a)))
    Call SaveSetting(ProgramName, "input" & a, "down", CInt(Pad_Down(a)))
    Call SaveSetting(ProgramName, "input" & a, "left", CInt(Pad_Left(a)))
    Call SaveSetting(ProgramName, "input" & a, "right", CInt(Pad_Right(a)))
    Call SaveSetting(ProgramName, "input" & a, "1", CInt(Pad_1(a)))
    Call SaveSetting(ProgramName, "input" & a, "2", CInt(Pad_2(a)))
    Call SaveSetting(ProgramName, "input" & a, "3", CInt(Pad_3(a)))
    Call SaveSetting(ProgramName, "input" & a, "1rapidfire", CInt(Pad_1RapidFire(a)))
    Call SaveSetting(ProgramName, "input" & a, "2rapidfire", CInt(Pad_2RapidFire(a)))
    Call SaveSetting(ProgramName, "input" & a, "3rapidfire", CInt(Pad_3RapidFire(a)))
    Call SaveSetting(ProgramName, "input" & a, "pause", CInt(Pad_Pause(a)))
    Call SaveSetting(ProgramName, "input" & a, "type", CLng(Pad_Type(a)))
    Call SaveSetting(ProgramName, "input" & a, "controller", CLng(Controller(a)))
    Call SaveSetting(ProgramName, "input" & a, "controllerenable", CBool(Controller_Enable(a)))
    Call SaveSetting(ProgramName, "input" & a, "c1", CLng(Controller_1(a)))
    Call SaveSetting(ProgramName, "input" & a, "c2", CLng(Controller_2(a)))
    Call SaveSetting(ProgramName, "input" & a, "c3", CLng(Controller_3(a)))
    Call SaveSetting(ProgramName, "input" & a, "c1rapidfire", CLng(Controller_1RapidFire(a)))
    Call SaveSetting(ProgramName, "input" & a, "c2rapidfire", CLng(Controller_2RapidFire(a)))
    Call SaveSetting(ProgramName, "input" & a, "c3rapidfire", CLng(Controller_3RapidFire(a)))
    Call SaveSetting(ProgramName, "input" & a, "cpause", CLng(Controller_Pause(a)))
  Next a
  

End Sub
